/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ErrorAuthenticationResponse;
import io.swagger.client.model.ErrorBadRequestResponse;
import io.swagger.client.model.ErrorInternalServerResponse;
import io.swagger.client.model.ErrorNotFoundResponse;
import io.swagger.client.model.ErrorServiceNotAvailableResponse;
import io.swagger.client.model.ErrorToManyRequestsResponse;
import io.swagger.client.model.Recipients;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RecipientsApi {
    private ApiClient apiClient;

    public RecipientsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RecipientsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getRecipients
     * @param objectLimit Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     * @param objectOffset Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     * @param filterJobId Query parameter to fetch after recipient related to specific fax job (optional)
     * @param filterSameAccount Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     * @param filterFaxNumber Query parameter to fetch recipients after his fax number (optional)
     * @param filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number (optional)
     * @param filterRecipientReference Query parameter to fetch recipients after his recipient reference (optional)
     * @param filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code (optional)
     * @param filterResultCode Query parameter to fetch recipients after his result code (optional)
     * @param filterResultText Query parameter to fetch recipients after his result text (optional)
     * @param sortField Available sort options for the result data array. (optional)
     * @param sortOrder Describes the order for used sort fields (optional, default to asc)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getRecipientsCall(Integer objectLimit, Integer objectOffset, String filterJobId, Boolean filterSameAccount, String filterFaxNumber, String filterFaxNumberNorm, String filterRecipientReference, String filterInternationalDialingCode, String filterResultCode, String filterResultText, String sortField, String sortOrder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/recipients";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (objectLimit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("objectLimit", objectLimit));
        if (objectOffset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("objectOffset", objectOffset));
        if (filterJobId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterJobId", filterJobId));
        if (filterSameAccount != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterSameAccount", filterSameAccount));
        if (filterFaxNumber != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterFaxNumber", filterFaxNumber));
        if (filterFaxNumberNorm != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterFaxNumberNorm", filterFaxNumberNorm));
        if (filterRecipientReference != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterRecipientReference", filterRecipientReference));
        if (filterInternationalDialingCode != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterInternationalDialingCode", filterInternationalDialingCode));
        if (filterResultCode != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterResultCode", filterResultCode));
        if (filterResultText != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("filterResultText", filterResultText));
        if (sortField != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortField", sortField));
        if (sortOrder != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortOrder", sortOrder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "ApiAuthKey" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getRecipientsValidateBeforeCall(Integer objectLimit, Integer objectOffset, String filterJobId, Boolean filterSameAccount, String filterFaxNumber, String filterFaxNumberNorm, String filterRecipientReference, String filterInternationalDialingCode, String filterResultCode, String filterResultText, String sortField, String sortOrder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getRecipientsCall(objectLimit, objectOffset, filterJobId, filterSameAccount, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * /recipients
     * Description: To obtain a list of recipients
     * @param objectLimit Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     * @param objectOffset Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     * @param filterJobId Query parameter to fetch after recipient related to specific fax job (optional)
     * @param filterSameAccount Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     * @param filterFaxNumber Query parameter to fetch recipients after his fax number (optional)
     * @param filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number (optional)
     * @param filterRecipientReference Query parameter to fetch recipients after his recipient reference (optional)
     * @param filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code (optional)
     * @param filterResultCode Query parameter to fetch recipients after his result code (optional)
     * @param filterResultText Query parameter to fetch recipients after his result text (optional)
     * @param sortField Available sort options for the result data array. (optional)
     * @param sortOrder Describes the order for used sort fields (optional, default to asc)
     * @return Recipients
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Recipients getRecipients(Integer objectLimit, Integer objectOffset, String filterJobId, Boolean filterSameAccount, String filterFaxNumber, String filterFaxNumberNorm, String filterRecipientReference, String filterInternationalDialingCode, String filterResultCode, String filterResultText, String sortField, String sortOrder) throws ApiException {
        ApiResponse<Recipients> resp = getRecipientsWithHttpInfo(objectLimit, objectOffset, filterJobId, filterSameAccount, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder);
        return resp.getData();
    }

    /**
     * /recipients
     * Description: To obtain a list of recipients
     * @param objectLimit Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     * @param objectOffset Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     * @param filterJobId Query parameter to fetch after recipient related to specific fax job (optional)
     * @param filterSameAccount Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     * @param filterFaxNumber Query parameter to fetch recipients after his fax number (optional)
     * @param filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number (optional)
     * @param filterRecipientReference Query parameter to fetch recipients after his recipient reference (optional)
     * @param filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code (optional)
     * @param filterResultCode Query parameter to fetch recipients after his result code (optional)
     * @param filterResultText Query parameter to fetch recipients after his result text (optional)
     * @param sortField Available sort options for the result data array. (optional)
     * @param sortOrder Describes the order for used sort fields (optional, default to asc)
     * @return ApiResponse&lt;Recipients&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Recipients> getRecipientsWithHttpInfo(Integer objectLimit, Integer objectOffset, String filterJobId, Boolean filterSameAccount, String filterFaxNumber, String filterFaxNumberNorm, String filterRecipientReference, String filterInternationalDialingCode, String filterResultCode, String filterResultText, String sortField, String sortOrder) throws ApiException {
        com.squareup.okhttp.Call call = getRecipientsValidateBeforeCall(objectLimit, objectOffset, filterJobId, filterSameAccount, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder, null, null);
        Type localVarReturnType = new TypeToken<Recipients>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * /recipients (asynchronously)
     * Description: To obtain a list of recipients
     * @param objectLimit Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     * @param objectOffset Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     * @param filterJobId Query parameter to fetch after recipient related to specific fax job (optional)
     * @param filterSameAccount Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     * @param filterFaxNumber Query parameter to fetch recipients after his fax number (optional)
     * @param filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number (optional)
     * @param filterRecipientReference Query parameter to fetch recipients after his recipient reference (optional)
     * @param filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code (optional)
     * @param filterResultCode Query parameter to fetch recipients after his result code (optional)
     * @param filterResultText Query parameter to fetch recipients after his result text (optional)
     * @param sortField Available sort options for the result data array. (optional)
     * @param sortOrder Describes the order for used sort fields (optional, default to asc)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRecipientsAsync(Integer objectLimit, Integer objectOffset, String filterJobId, Boolean filterSameAccount, String filterFaxNumber, String filterFaxNumberNorm, String filterRecipientReference, String filterInternationalDialingCode, String filterResultCode, String filterResultText, String sortField, String sortOrder, final ApiCallback<Recipients> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRecipientsValidateBeforeCall(objectLimit, objectOffset, filterJobId, filterSameAccount, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Recipients>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
