/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * Describes the request body for the fax job
 */
@Schema(description = "Describes the request body for the fax job")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-05-09T10:16:59.047+02:00[Europe/Berlin]")
public class JobPostOptions {
  @SerializedName("title")
  private String title = null;

  @SerializedName("timeToSend")
  private OffsetDateTime timeToSend = null;

  @SerializedName("timeToSendUntil")
  private OffsetDateTime timeToSendUntil = null;

  @SerializedName("faxHeader")
  private Boolean faxHeader = null;

  @SerializedName("faxHeaderFrom")
  private String faxHeaderFrom = null;

  @SerializedName("stationID")
  private String stationID = null;

  @SerializedName("clip")
  private String clip = null;

  @SerializedName("defaultInternationalDialingCode")
  private String defaultInternationalDialingCode = null;

  @SerializedName("costCenter")
  private String costCenter = null;

  @SerializedName("saveDocuments")
  private Boolean saveDocuments = null;

  public JobPostOptions title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Describes a title of the fax job. If not set the current date time will be used as title
   * @return title
  **/
  @Schema(example = "Fax Job ABC 123", description = "Describes a title of the fax job. If not set the current date time will be used as title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public JobPostOptions timeToSend(OffsetDateTime timeToSend) {
    this.timeToSend = timeToSend;
    return this;
  }

   /**
   * Describes the date the fax should be sent. The format must comply with ISO 8601 and must contain date and time. Date can not be in the past or more than 14 day into the future. If not set the current date time will be used as timeToSend
   * @return timeToSend
  **/
  @Schema(example = "2022-01-01T10:00+02:00", description = "Describes the date the fax should be sent. The format must comply with ISO 8601 and must contain date and time. Date can not be in the past or more than 14 day into the future. If not set the current date time will be used as timeToSend")
  public OffsetDateTime getTimeToSend() {
    return timeToSend;
  }

  public void setTimeToSend(OffsetDateTime timeToSend) {
    this.timeToSend = timeToSend;
  }

  public JobPostOptions timeToSendUntil(OffsetDateTime timeToSendUntil) {
    this.timeToSendUntil = timeToSendUntil;
    return this;
  }

   /**
   * Describes the date the fax can be sent until. The format must comply with ISO 8601 and must contain date and time. DateTime must be 5 minutes after TimeToSend. If not set the date will set to 2030-12-31
   * @return timeToSendUntil
  **/
  @Schema(example = "2022-01-01T10:00+02:00", description = "Describes the date the fax can be sent until. The format must comply with ISO 8601 and must contain date and time. DateTime must be 5 minutes after TimeToSend. If not set the date will set to 2030-12-31")
  public OffsetDateTime getTimeToSendUntil() {
    return timeToSendUntil;
  }

  public void setTimeToSendUntil(OffsetDateTime timeToSendUntil) {
    this.timeToSendUntil = timeToSendUntil;
  }

  public JobPostOptions faxHeader(Boolean faxHeader) {
    this.faxHeader = faxHeader;
    return this;
  }

   /**
   * Describes if the fax header should used or not for the fax job. If not set the value from api account will be used
   * @return faxHeader
  **/
  @Schema(example = "true", description = "Describes if the fax header should used or not for the fax job. If not set the value from api account will be used")
  public Boolean isFaxHeader() {
    return faxHeader;
  }

  public void setFaxHeader(Boolean faxHeader) {
    this.faxHeader = faxHeader;
  }

  public JobPostOptions faxHeaderFrom(String faxHeaderFrom) {
    this.faxHeaderFrom = faxHeaderFrom;
    return this;
  }

   /**
   * Describes the header part from in the fax header (if its used) of the a fax job. If not set the value from api account will be used
   * @return faxHeaderFrom
  **/
  @Schema(example = "Max Mustermann", description = "Describes the header part from in the fax header (if its used) of the a fax job. If not set the value from api account will be used")
  public String getFaxHeaderFrom() {
    return faxHeaderFrom;
  }

  public void setFaxHeaderFrom(String faxHeaderFrom) {
    this.faxHeaderFrom = faxHeaderFrom;
  }

  public JobPostOptions stationID(String stationID) {
    this.stationID = stationID;
    return this;
  }

   /**
   * Describes the source identifier, which will be displayed during the transmission and appears on the receipt protocol. If not set the value from api account will be used
   * @return stationID
  **/
  @Schema(example = "test12345", description = "Describes the source identifier, which will be displayed during the transmission and appears on the receipt protocol. If not set the value from api account will be used")
  public String getStationID() {
    return stationID;
  }

  public void setStationID(String stationID) {
    this.stationID = stationID;
  }

  public JobPostOptions clip(String clip) {
    this.clip = clip;
    return this;
  }

   /**
   * Describes the Calling Line Identification Presentation (Clip). It is the transferred dialing number before the transmission of the fax document. If not set the value from api account will be used
   * @return clip
  **/
  @Schema(example = "0525187929310", description = "Describes the Calling Line Identification Presentation (Clip). It is the transferred dialing number before the transmission of the fax document. If not set the value from api account will be used")
  public String getClip() {
    return clip;
  }

  public void setClip(String clip) {
    this.clip = clip;
  }

  public JobPostOptions defaultInternationalDialingCode(String defaultInternationalDialingCode) {
    this.defaultInternationalDialingCode = defaultInternationalDialingCode;
    return this;
  }

   /**
   * Describes the default International Dialing Code which will be used for fax numbers without international area code. If not set the value from api account will be used
   * @return defaultInternationalDialingCode
  **/
  @Schema(example = "0049", description = "Describes the default International Dialing Code which will be used for fax numbers without international area code. If not set the value from api account will be used")
  public String getDefaultInternationalDialingCode() {
    return defaultInternationalDialingCode;
  }

  public void setDefaultInternationalDialingCode(String defaultInternationalDialingCode) {
    this.defaultInternationalDialingCode = defaultInternationalDialingCode;
  }

  public JobPostOptions costCenter(String costCenter) {
    this.costCenter = costCenter;
    return this;
  }

   /**
   * Describes the to used cost center for the fax job. If not set the value from api account will be used
   * @return costCenter
  **/
  @Schema(example = "Kösten", description = "Describes the to used cost center for the fax job. If not set the value from api account will be used")
  public String getCostCenter() {
    return costCenter;
  }

  public void setCostCenter(String costCenter) {
    this.costCenter = costCenter;
  }

  public JobPostOptions saveDocuments(Boolean saveDocuments) {
    this.saveDocuments = saveDocuments;
    return this;
  }

   /**
   * Describes if the uploaded template documents and resulting preview documents for the fax job should be stored or not. If not set the value from api account will be used
   * @return saveDocuments
  **/
  @Schema(example = "false", description = "Describes if the uploaded template documents and resulting preview documents for the fax job should be stored or not. If not set the value from api account will be used")
  public Boolean isSaveDocuments() {
    return saveDocuments;
  }

  public void setSaveDocuments(Boolean saveDocuments) {
    this.saveDocuments = saveDocuments;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    JobPostOptions jobPostOptions = (JobPostOptions) o;
    return Objects.equals(this.title, jobPostOptions.title) &&
        Objects.equals(this.timeToSend, jobPostOptions.timeToSend) &&
        Objects.equals(this.timeToSendUntil, jobPostOptions.timeToSendUntil) &&
        Objects.equals(this.faxHeader, jobPostOptions.faxHeader) &&
        Objects.equals(this.faxHeaderFrom, jobPostOptions.faxHeaderFrom) &&
        Objects.equals(this.stationID, jobPostOptions.stationID) &&
        Objects.equals(this.clip, jobPostOptions.clip) &&
        Objects.equals(this.defaultInternationalDialingCode, jobPostOptions.defaultInternationalDialingCode) &&
        Objects.equals(this.costCenter, jobPostOptions.costCenter) &&
        Objects.equals(this.saveDocuments, jobPostOptions.saveDocuments);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, timeToSend, timeToSendUntil, faxHeader, faxHeaderFrom, stationID, clip, defaultInternationalDialingCode, costCenter, saveDocuments);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class JobPostOptions {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    timeToSend: ").append(toIndentedString(timeToSend)).append("\n");
    sb.append("    timeToSendUntil: ").append(toIndentedString(timeToSendUntil)).append("\n");
    sb.append("    faxHeader: ").append(toIndentedString(faxHeader)).append("\n");
    sb.append("    faxHeaderFrom: ").append(toIndentedString(faxHeaderFrom)).append("\n");
    sb.append("    stationID: ").append(toIndentedString(stationID)).append("\n");
    sb.append("    clip: ").append(toIndentedString(clip)).append("\n");
    sb.append("    defaultInternationalDialingCode: ").append(toIndentedString(defaultInternationalDialingCode)).append("\n");
    sb.append("    costCenter: ").append(toIndentedString(costCenter)).append("\n");
    sb.append("    saveDocuments: ").append(toIndentedString(saveDocuments)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
